//Glock.cs

//audio
datablock AudioProfile(GlockShot1Sound)
{
   filename    = "./GlockShot1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(GlockClipout1Sound)
{
   filename    = "./CLIPOUT.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(GlockClipin1Sound)
{
   filename    = "./CLIPIN.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("Glock",   '<bitmap:add-ons/Weapon_Glock/CI_Glock> %1',    '%2 <bitmap:add-ons/Weapon_Glock/CI_Glock> %1',0.2,1);
datablock ProjectileData(GlockProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::Glock;
   radiusDamageType    = $DamageType::Glock;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Glock Bullet";
};

//////////
// item //
//////////
datablock ItemData(GlockItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Glock.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Glock";
	iconName = "./icon_Glock";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = GlockImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(GlockImage)
{
   // Basic Item properties
   shapeFile = "./Glock.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = "";
   projectile = GlockProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = GlockItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	 stateTransitionOnTimeout[0] 	= "AmmoCheck";
	stateSound[0]					= weaponSwitchSound;
	

	stateName[3]                     = "Ready";
	stateTransitionOnTriggerDown[3]  = "Fire";
	stateAllowImageChange[3]         = true;
	stateSequence[3]				 = "Ready";
	stateTransitionOnNoAmmo[3] = "Reload";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "Smoke";
	stateTimeoutValue[4]            = 0.14;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= gunFlashEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= GlockShot1Sound;
	stateEjectShell[4]       		= true;
	
	stateName[5] 					= "AmmoCheck";
	stateTransitionOnTimeout[5] 	= "Ready";
	stateAllowImageChange[5] 		= true;
	stateScript[5] 					= "onAmmoCheck";


	stateName[6] 					= "Smoke";
	stateEmitter[6]					= gunSmokeEmitter;
	stateAllowImageChange[6] 		= false;
	stateEmitterTime[6]				= 0.05;
	stateEmitterNode[6]				= "muzzleNode";
	stateTimeoutValue[6]            = 0.01;
	stateTransitionOnTimeout[6] 	= "AmmoCheck";

	stateName[7]					= "Reload";
	stateSequence[7]                = "Reload";
	stateTimeoutValue[7]            = 0.01;
	stateTransitionOnTimeout[7]		= "Magout";
	stateSequence[7]				= "Ready";
	
	
	stateName[8]					= "Magout";
	stateSequence[8]				= "Ready";
	stateTimeoutValue[8]            = 1.0;
	stateWaitForTimeout[8]			= true;
	stateAllowImageChange[8] 		= true;
	stateScript[8] 					= "onReloadStart";
	stateSequence[8]                = "Magout";
	stateTransitionOnTimeout[8]		= "Magin";

	
	stateName[9]					= "Magin";
	stateSequence[9]                = "Magin";
	stateTransitionOnTimeout[9]		= "Ready";
	stateTimeoutValue[9]        	= 1.5;
	stateWaitForTimeout[9]			= true;
	stateAllowImageChange[9] 		= true;
	stateScript[9] 					= "onReload";
	

};
//### Functions

function GlockImage::onFire(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.00005;
	}
	else
	{
		%spread = 0.001;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	//%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%projectile = %this.projectile;
	
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}


function GlockImage::onAmmoCheck(%this,%obj,%slot) 
	{	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	
		else
		%obj.setImageAmmo(%slot,1);}

function GlockImage::onReloadStart(%this,%obj,%slot) 
{
	%obj.toolAmmo[%obj.currTool] = 0;
	serverPlay3D(GlockClipout1Sound,%obj.getPosition());
	%obj.playThread(2,shiftUp);
}

function GlockImage::onReload(%this,%obj,%slot) 
{
	%obj.toolAmmo[%obj.currTool] = 12;
	%obj.setImageAmmo(%slot,1);
	serverPlay3D(GlockClipin1Sound,%obj.getPosition());
	%obj.playThread(2,plant);
}
